package org.fuseri.moduleexercise.exercise;

import lombok.Builder;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import org.fuseri.moduleexercise.common.DomainObject;
import org.fuseri.moduleexercise.question.Question;

import java.util.HashSet;
import java.util.Objects;
import java.util.Set;

/**
 * Represent exercise entity
 */
@Getter
@Setter
@NoArgsConstructor
@Builder
public class Exercise extends DomainObject {

    private String name;

    private String description;

    private String lectureId;

    private Set<Question> questions = new HashSet<>();

    /**
     * Constructor of exercise
     *
     * @param name        exercise name
     * @param description exercise description
     * @param lectureId   id of lecture to which exercise belongs
     * @param questions   question exercise contains
     */
    public Exercise(String name, String description, String lectureId, Set<Question> questions) {
        this.name = name;
        this.description = description;
        this.lectureId = lectureId;
        this.questions = Objects.requireNonNullElseGet(questions, HashSet::new);
    }
}
