package org.fuseri.moduleexercise.question;

import org.fuseri.model.dto.exercise.QuestionCreateDto;
import org.fuseri.model.dto.exercise.QuestionDto;
import org.fuseri.moduleexercise.common.DomainMapper;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

/**
 * Mapper between Questions and their corresponding DTOs
 */
@Mapper
public interface QuestionMapper extends DomainMapper<Question, QuestionDto> {

    /**
     * Convert DTO of type QuestionCreateDto to Question
     *
     * @param dto DTO to be converted
     * @return corresponding Question entity created from DTO
     */
    @Mapping(target = "answers", ignore = true)
    Question fromCreateDto(QuestionCreateDto dto);
}
